#include "wx/wx.h"
#include "algorithm.h"
#include "alg_try.h"
#include "main.h"

// Just some testalgorithms which don't do much useful things :)

AlgTry1::AlgTry1() : Algorithm("AlgTry1", 1)
{
}

void AlgTry1::Execute( wxImage * bmp_)
{
    fprintf(stderr, "\nAlgTry1::Execute");
    unsigned char* data = bmp_->GetData();
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = 255-data[y*lineSize+x+1];
            data[y*lineSize+x+1] = 255-data[y*lineSize+x+2];
            data[y*lineSize+x+2] = 255-data[y*lineSize+x];
        }
    }
}

AlgTry2::AlgTry2() : Algorithm("AlgTry2", 2)
{
}

void AlgTry2::Execute( wxImage * bmp_, wxImage * bmp2_)
{
    fprintf(stderr, "\nAlgTry2::Execute");
    unsigned char* data = bmp_->GetData();
    unsigned char* data2 = bmp2_->GetData();
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;
    int avg[3];
    avg[0] = 0;
    avg[1] = 0;
    avg[2] = 0;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            avg[0] += data[y*lineSize+x];
            avg[1] += data[y*lineSize+x+1];
            avg[2] += data[y*lineSize+x+2];
        }
    }
    
    avg[0] /= width*height;
    avg[1] /= width*height;
    avg[2] /= width*height;   
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            if ( data[y*lineSize+x] < avg[0] )
                data2[y*lineSize+x] = 0;
            else
                data2[y*lineSize+x] = 255;
            if ( data[y*lineSize+x+1] < avg[1] )
                data2[y*lineSize+x+1] = 0;
            else
                data2[y*lineSize+x+1] = 255;
            if ( data[y*lineSize+x+2] < avg[2] )
                data2[y*lineSize+x+2] = 0;
            else
                data2[y*lineSize+x+2] = 255;
            
//            data[y*lineSize+x] = 255-data[y*lineSize+x+2];
//            data[y*lineSize+x+1] = 255-data[y*lineSize+x];
//            data[y*lineSize+x+2] = 255-data[y*lineSize+x+1];
        }
    }
}


AlgTry3::AlgTry3() : Algorithm("AlgTry3", 3)
{
}

void AlgTry3::Execute( wxImage * bmp_, wxImage * bmp2_, wxImage * bmp3_)
{
    fprintf(stderr, "\nAlgTry3::Execute");
    unsigned char* data = bmp_->GetData();
    unsigned char* data2 = bmp2_->GetData();
    unsigned char* data3 = bmp3_->GetData();
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = 255-data[y*lineSize+x];
            data[y*lineSize+x+1] = 255-data[y*lineSize+x+1];
            data[y*lineSize+x+2] = 255-data[y*lineSize+x+2];
        
            data2[y*lineSize+x] = data[y*lineSize+x+1];
            data2[y*lineSize+x+1] = data[y*lineSize+x+2];
            data2[y*lineSize+x+2] = data[y*lineSize+x];
            
            data3[y*lineSize+x] = data[y*lineSize+x+2];
            data3[y*lineSize+x+1] = data[y*lineSize+x];
            data3[y*lineSize+x+2] = data[y*lineSize+x+1];
        }
    }
}

RGBtoBlackWhiteAvg::RGBtoBlackWhiteAvg() : Algorithm("RGBtoBlackWhiteAvg", 1)
{
}

void RGBtoBlackWhiteAvg::Execute( wxImage * bmp_)
{
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;
    unsigned char* data = bmp_->GetData();
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = (data[y*lineSize+x] + data[y*lineSize+x+1] + data[y*lineSize+x+2]) / 3;
            data[y*lineSize+x+1] = data[y*lineSize+x];
            data[y*lineSize+x+2] = data[y*lineSize+x];
        }
    }
}

RGBtoBlackWhiteNTSC::RGBtoBlackWhiteNTSC() : Algorithm("RGBtoBlackWhiteNTSC", 1)
{
}

void RGBtoBlackWhiteNTSC::Execute( wxImage * bmp_)
{
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;
    unsigned char* data = bmp_->GetData();
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = (int) (0.299f * (float)data[y*lineSize+x]
                                        + 0.587f * (float)data[y*lineSize+x+1]
                                        + 0.114f * (float)data[y*lineSize+x+2]);
            data[y*lineSize+x+1] = data[y*lineSize+x];
            data[y*lineSize+x+2] = data[y*lineSize+x];
        }
    }
}

MovieDiffImage::MovieDiffImage() : Algorithm("AlgMovieDiffImage", 3)
{
}

void MovieDiffImage::Execute( wxImage * bmp_, wxImage * bmp2_, wxImage * bmp3_)
{
    wxImage * old1 = PIXALCO.GetImageFromMovieBuffer(1);
    wxImage * old2 = PIXALCO.GetImageFromMovieBuffer(9);
    if ( DoesNeedNewImage( bmp_, old1, 0 ) )
    {
        return;
    }
    if ( DoesNeedNewImage( bmp_, old2, 0 ) )
    {
        return;
    }

    unsigned char* dataNew = bmp_->GetData();
    unsigned char* dataOld1 = old1->GetData();
    unsigned char* dataOld2 = old2->GetData();
    unsigned char* dataTarget1 = bmp2_->GetData();
    unsigned char* dataTarget2 = bmp3_->GetData();
    int width = bmp_->GetWidth();
    int height = bmp_->GetHeight();
    int lineSize = width * 3;

    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            dataTarget1[y*lineSize+x] = abs( dataOld1[y*lineSize+x] - dataNew[y*lineSize+x] );
            dataTarget1[y*lineSize+x+1] = abs( dataOld1[y*lineSize+x+1] - dataNew[y*lineSize+x+1] );
            dataTarget1[y*lineSize+x+2] = abs( dataOld1[y*lineSize+x+2] - dataNew[y*lineSize+x+2] );

            dataTarget2[y*lineSize+x] = abs( dataOld2[y*lineSize+x] - dataNew[y*lineSize+x] );
            dataTarget2[y*lineSize+x+1] = abs( dataOld2[y*lineSize+x+1] - dataNew[y*lineSize+x+1] );
            dataTarget2[y*lineSize+x+2] = abs( dataOld2[y*lineSize+x+2] - dataNew[y*lineSize+x+2] );
        }
    }    
}
