#ifndef ALGORITHM_H
#define ALGORITHM_H

#include <string>

using namespace std;

class Algorithm
{
public:
    Algorithm(const string &name_, int nrParams_);
    
    virtual void Execute( wxImage * bmp_) { cerr << "Execute not overloaded for 1 param" << endl; };
    virtual void Execute( wxImage * bmp_, wxImage * bmp2_) { cerr << "Execute not overloaded for 2 params" << endl; };
    virtual void Execute( wxImage * bmp_, wxImage * bmp2_, wxImage * bmp3_) { cerr << "Execute not overloaded for 3 param" << endl; };

    const string& GetName()     { return mName; }
    int GetNrParams()           { return mNrParams; }
    
    // id is 1 or 2
    virtual bool DoesNeedNewImage( wxImage * origin, wxImage * target, int targetId );
    virtual wxImage* MakeNewImage( wxImage * origin, int targetId );
    
private:
    string mName;
    int mNrParams;

	// constrains (size, etc.)
};

#endif // ALGORITHM_H
